#include <display_syscalls.h>
#include <RTC_syscalls.h>
#include "minefield.h"
#include "fonctionUtile.h"
#include "number.h"
#include "game.h"
#include "menu.h"




bool Is_win (int** tab, eTypeAction** tab_act, int height, int lenght)
{
    int i;
    int j;

    for ( i=0 ; i<lenght ; i++)
    {
        for ( j=0 ; j<height ; j++)
        {
            if (tab[j][i]!=-1 && tab_act[j][i]==none)
                return false;

            if (tab[j][i]!=-1 && tab_act[j][i]==flaged)
                return false;
        }
    }
    return true;
}

void Display_cursor (int x, int y, tPos scrolling)
{
    const unsigned char curseur[]={
        0,1,1,1,1,1,1,1,1,1,1,1,
        0,0,1,1,1,1,1,1,1,1,1,1,
        0,2,0,1,1,1,1,1,1,1,1,1,
        0,2,3,0,1,1,1,1,1,1,1,1,
        0,2,2,2,0,1,1,1,1,1,1,1,
        0,2,2,2,2,0,1,1,1,1,1,1,
        0,2,2,2,2,2,0,1,1,1,1,1,
        0,2,2,2,2,2,2,0,1,1,1,1,
        0,2,2,2,2,2,2,2,0,1,1,1,
        0,2,2,2,2,2,2,2,2,0,1,1,
        0,2,2,2,2,2,2,3,4,2,0,1,
        0,2,2,2,2,2,2,0,0,0,0,0,
        0,2,2,2,0,3,2,0,1,1,1,1,
        0,2,2,0,0,2,2,0,1,1,1,1,
        0,2,0,1,1,0,2,2,0,1,1,1,
        0,0,1,1,1,0,2,2,0,1,1,1,
        0,1,1,1,1,1,0,2,2,0,1,1,
        1,1,1,1,1,1,0,4,2,0,1,1,
        1,1,1,1,1,1,1,0,2,2,0,1,
        1,1,1,1,1,1,1,0,2,2,0,1,
        1,1,1,1,1,1,1,1,0,0,1,1
    };
    const color_t curseur_palette[5]={
        0x0,0x9a53,0xffff,0xf7be,0xf7de
    };
    CopySpriteNbitMasked(curseur,x+scrolling.x,y+scrolling.y,12,21,curseur_palette,0x9a53,8);
}


tSaveData Game(tSaveData game, tMinefield minef)
{
    int i;

    int lenght;
    int height;
    int time_start;
    int time_actual=0;
    eSmiley smiley;
    tPos scrolling;
    tPos pos_cursor;
    int number_mines;
    int number_flag;

    eTypeAction**   minefield_action;
    int**           minefield;

    bool left_mouse_clicked;
    bool right_mouse_clicked;
    bool map_generated;
    bool game_win;
    bool game_over;
    bool newgame_choosen;
    do
    {
        game.num_game++;
        for (i=0;i<game.num_game*2;i++)
            Rand32(0,50);
        lenght = minef.width;
        height = minef.height;
        time_actual=0;
        smiley = happy;
        scrolling.x = (384-16*lenght)/2;
        scrolling.y = 40+(216-16*height)/2;
        pos_cursor.x = 8*lenght;
        pos_cursor.y = 8*height-40;
        number_mines = minef.number_mine;
        number_flag = 0;
        minefield_action    = New_tab2dim_eTypeAction(height, lenght);
        minefield           = New_tab2dim_int(height, lenght);
        Init_tab2dim_int(minefield, height, lenght);
        Init_tab2dim_eTypeAction(minefield_action, height, lenght);

        map_generated = false;
        game_win=false;
        game_over=false;
        newgame_choosen = false;
        left_mouse_clicked = keydown(78);
        right_mouse_clicked = keydown(77);
        do
        {
            game_win = Is_win(minefield, minefield_action, height, lenght);
            scrolling = Scroll_minefield(pos_cursor, scrolling, height, lenght);
            if (!game_over && !game_win)
                time_actual = RTC_GetTicks();
            Display_minefield(minefield, minefield_action, height, lenght, scrolling);
            if (keydown(27) && (pos_cursor.x+6)/16<lenght) pos_cursor.x+=6;
            if (keydown(28) && pos_cursor.y-6>3) pos_cursor.y-=6;
            if (keydown(37) && (pos_cursor.y+14)/16<height) pos_cursor.y+=6;
            if (keydown(38) && pos_cursor.x-6>3) pos_cursor.x-=6;
            if (keydown(48))
            {
                newgame_choosen = Menu(&minef);
                Bdisp_AllClr_VRAM();
            }
            if (!game_win && !game_over)
            {
                if (keydown(78))
                {
                    Display_clicked_field(minefield_action, pos_cursor.x/16, pos_cursor.y/16, scrolling);
                    left_mouse_clicked = true;
                    smiley = tension;
                }
                else if (!keydown(78) && left_mouse_clicked) //78 isn't clicked anymore
                {
                    if (!map_generated)
                    {
                        Generate_minefield(minefield, height, lenght, number_mines,pos_cursor.x/16,pos_cursor.y/16);
                        time_start = RTC_GetTicks();
                        map_generated = true;
                    }
                    Select_rec (minefield,minefield_action,height,lenght,pos_cursor.x/16, pos_cursor.y/16);
                    left_mouse_clicked = false;
                    if (minefield[pos_cursor.y/16][pos_cursor.x/16]==-1) //hit the mine
                    {
                        game_over = true;
                        minefield_action[pos_cursor.y/16][pos_cursor.x/16]=clicked_on_mine;
                    }
                    else
                        smiley = happy;

                }

                if (keydown(77) && minefield_action[pos_cursor.y/16][pos_cursor.x/16] == none)
                {
                    right_mouse_clicked  = true;
                }
                else if (!keydown(77) &&  right_mouse_clicked && minefield_action[pos_cursor.y/16][pos_cursor.x/16] == none)
                {
                    minefield_action[pos_cursor.y/16][pos_cursor.x/16] = flaged;
                    right_mouse_clicked = false;
                    number_flag++;
                }
                else if (keydown(77) && minefield_action[pos_cursor.y/16][pos_cursor.x/16] == flaged)
                {
                    right_mouse_clicked  = true;
                }
                else if (!keydown(77) &&  right_mouse_clicked && minefield_action[pos_cursor.y/16][pos_cursor.x/16] == flaged)
                {
                    minefield_action[pos_cursor.y/16][pos_cursor.x/16] = none;
                    right_mouse_clicked = false;
                    number_flag--;
                }
            }
            if (game_win)
                smiley = win;
            if (game_over)
                smiley = dead;
            if (game_over || game_win)
                Sole_minefield(minefield,minefield_action, height, lenght, smiley );
            Display_number(scrolling,height,lenght,(map_generated?(time_actual-time_start)/126:0),number_mines-number_flag);
            Display_smiley(scrolling,height,lenght,smiley);
            Display_cursor (pos_cursor.x,pos_cursor.y,scrolling);
            Bdisp_PutDisp_DD();
        }while(!keydown(47) &&  !newgame_choosen);
        Bdisp_AllClr_VRAM();

        Free_tab2dim_eTypeAction(minefield_action, height, lenght);
        Free_tab2dim_int(minefield, height, lenght);
    }while(!keydown(47));
    return game;
}

